comment		*

Algorithm		: 3DES	( Block Cipher )
Block		: 8 bytes 
KeySize		: 128bit <= KeySize <= 192bit ( 16 bytes <= KeySize <=24 bytes )

Abstract		:

			3DES takes either a <= 128bit key and uses one key twice or takes a  
    			<= 192bit key and uses each once (again discarding every 8th bit) 

Usage		:

			push	ptrInkey_length
			push	offset ptrInkey	( 16 bytes <= KeySize <=24 bytes data to setkey )
			call	_3des_setkey	( setkey )
			
			push	offset ptrOutdata	( 8bytes encrypt result buffer )
			push	offset ptrIndata	( 8bytes data to encrypt )
			call	_3des_encrypt	( encrypt )
			
			push	offset ptrOutdata	( 8bytes decrypt result buffer )
			push	offset ptrIndata	( 8bytes data to decrypt )
			call	_3des_decrypt	( decrypt )
			
Coded by x3chun	( 2004.06.10 )
		( x3chun@korea.com  or  x3chun@hanyang.ac.kr )  ( http://x3chun.ce.ro )
		
comment		*

DES_ENCRYPT	macro	LL,R,S,X

		mov	ebp,R
		xor	ebp,[_3des_roundkey+X+S*4]	; u
		mov	edx,R
		xor	edx,[_3des_roundkey+X+S*4+4] ; t
		ror	edx,4
		mov	esi,ebp			; u
		mov	edi,ebp			; u
		mov	ecx,ebp			; u
		shr	esi,2
		and	esi,3fh
		shr	edi,10
		and	edi,3fh
		shr	ecx,18
		and	ecx,3fh
		shr	ebp,26
		and	ebp,3fh
		xor	LL,[des_SPtrans+0*64*4+esi*4]
		xor	LL,[des_SPtrans+2*64*4+edi*4]
		xor	LL,[des_SPtrans+4*64*4+ecx*4]
		xor	LL,[des_SPtrans+6*64*4+ebp*4]
		mov	esi,edx
		mov	edi,edx
		mov	ecx,edx
		shr	esi,2
		and	esi,3fh
		shr	edi,10
		and	edi,3fh
		shr	ecx,18
		and	ecx,3fh
		shr	edx,26
		and	edx,3fh
		xor	LL,[des_SPtrans+1*64*4+esi*4]
		xor	LL,[des_SPtrans+3*64*4+edi*4]
		xor	LL,[des_SPtrans+5*64*4+ecx*4]
		xor	LL,[des_SPtrans+7*64*4+edx*4]
		
endm
	                      
include		destabs.inc
include		desm.inc

_3des_setkey	proto	:DWORD, :DWORD
_3des_encrypt	proto	:DWORD, :DWORD
_3des_decrypt	proto	:DWORD, :DWORD

.data?

_3des_roundkey	dd	DES_NO_ROUNDKEY*3	dup(?)

.code

_3des_setkey	proc	ptrInkey:DWORD, ptrInkey_length:DWORD

		pushad
		mov	esi,[esp+28h]	; ptrInkey
		push	esi
		call	des_setkey
		push	offset _3des_roundkey
		push	offset des_roundkey
		call	_move
		lea	esi,[esi+8]
		push	esi
		call	des_setkey
		push	offset _3des_roundkey+128
		push	offset des_roundkey
		call	_move
		mov	ecx,[esp+2ch]	; ptrInkey_length
		cmp	ecx,16
		ja	@_r1
		push	offset _3des_roundkey+128*2
		push	offset _3des_roundkey
		call	_move	
		jmp	@_r2
@_r1:
		lea	esi,[esi+8]
		push	esi
		call	des_setkey
		push	offset _3des_roundkey+128*2
		push	offset des_roundkey
		call	_move
@_r2:
		popad
		ret
		
_3des_setkey	endp

_3des_encrypt	proc	ptrIndata:DWORD, ptrOutdata:DWORD

		pushad
		mov	esi,[esp+28h]	; ptrIndata
		mov	eax,[esi]		; r
		mov	ebx,[esi+4]	; l
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax, 0,0
		DES_ENCRYPT          eax,ebx, 2,0
		DES_ENCRYPT          ebx,eax, 4,0
		DES_ENCRYPT          eax,ebx, 6,0
		DES_ENCRYPT          ebx,eax, 8,0
		DES_ENCRYPT          eax,ebx,10,0
		DES_ENCRYPT          ebx,eax,12,0
		DES_ENCRYPT          eax,ebx,14,0
		DES_ENCRYPT          ebx,eax,16,0
		DES_ENCRYPT          eax,ebx,18,0
		DES_ENCRYPT          ebx,eax,20,0
		DES_ENCRYPT          eax,ebx,22,0
		DES_ENCRYPT          ebx,eax,24,0
		DES_ENCRYPT          eax,ebx,26,0
		DES_ENCRYPT          ebx,eax,28,0
		DES_ENCRYPT          eax,ebx,30,0
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		xchg	eax,ebx
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax,30,128
		DES_ENCRYPT          eax,ebx,28,128
		DES_ENCRYPT          ebx,eax,26,128
		DES_ENCRYPT          eax,ebx,24,128
		DES_ENCRYPT          ebx,eax,22,128
		DES_ENCRYPT          eax,ebx,20,128
		DES_ENCRYPT          ebx,eax,18,128
		DES_ENCRYPT          eax,ebx,16,128
		DES_ENCRYPT          ebx,eax,14,128
		DES_ENCRYPT          eax,ebx,12,128
		DES_ENCRYPT          ebx,eax,10,128
		DES_ENCRYPT          eax,ebx, 8,128
		DES_ENCRYPT          ebx,eax, 6,128
		DES_ENCRYPT          eax,ebx, 4,128
		DES_ENCRYPT          ebx,eax, 2,128
		DES_ENCRYPT          eax,ebx, 0,128
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		xchg	eax,ebx
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax, 0,128*2
		DES_ENCRYPT          eax,ebx, 2,128*2
		DES_ENCRYPT          ebx,eax, 4,128*2
		DES_ENCRYPT          eax,ebx, 6,128*2
		DES_ENCRYPT          ebx,eax, 8,128*2
		DES_ENCRYPT          eax,ebx,10,128*2
		DES_ENCRYPT          ebx,eax,12,128*2
		DES_ENCRYPT          eax,ebx,14,128*2
		DES_ENCRYPT          ebx,eax,16,128*2
		DES_ENCRYPT          eax,ebx,18,128*2
		DES_ENCRYPT          ebx,eax,20,128*2
		DES_ENCRYPT          eax,ebx,22,128*2
		DES_ENCRYPT          ebx,eax,24,128*2
		DES_ENCRYPT          eax,ebx,26,128*2
		DES_ENCRYPT          ebx,eax,28,128*2
		DES_ENCRYPT          eax,ebx,30,128*2
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		mov	edi,[esp+2ch]	; ptrOutdata
		mov	[edi],ebx
		mov	[edi+4],eax
		popad
		ret
		
_3des_encrypt	endp

_3des_decrypt	proc	ptrIndata:DWORD, ptrOutdata:DWORD

		pushad
		mov	esi,[esp+28h]	; ptrIndata
		mov	eax,[esi]		; r
		mov	ebx,[esi+4]	; l
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax,30,128*2
		DES_ENCRYPT          eax,ebx,28,128*2
		DES_ENCRYPT          ebx,eax,26,128*2
		DES_ENCRYPT          eax,ebx,24,128*2
		DES_ENCRYPT          ebx,eax,22,128*2
		DES_ENCRYPT          eax,ebx,20,128*2
		DES_ENCRYPT          ebx,eax,18,128*2
		DES_ENCRYPT          eax,ebx,16,128*2
		DES_ENCRYPT          ebx,eax,14,128*2
		DES_ENCRYPT          eax,ebx,12,128*2
		DES_ENCRYPT          ebx,eax,10,128*2
		DES_ENCRYPT          eax,ebx, 8,128*2
		DES_ENCRYPT          ebx,eax, 6,128*2
		DES_ENCRYPT          eax,ebx, 4,128*2
		DES_ENCRYPT          ebx,eax, 2,128*2
		DES_ENCRYPT          eax,ebx, 0,128*2
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		xchg	eax,ebx
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax, 0,128
		DES_ENCRYPT          eax,ebx, 2,128
		DES_ENCRYPT          ebx,eax, 4,128
		DES_ENCRYPT          eax,ebx, 6,128
		DES_ENCRYPT          ebx,eax, 8,128
		DES_ENCRYPT          eax,ebx,10,128
		DES_ENCRYPT          ebx,eax,12,128
		DES_ENCRYPT          eax,ebx,14,128
		DES_ENCRYPT          ebx,eax,16,128
		DES_ENCRYPT          eax,ebx,18,128
		DES_ENCRYPT          ebx,eax,20,128
		DES_ENCRYPT          eax,ebx,22,128
		DES_ENCRYPT          ebx,eax,24,128
		DES_ENCRYPT          eax,ebx,26,128
		DES_ENCRYPT          ebx,eax,28,128
		DES_ENCRYPT          eax,ebx,30,128
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		xchg	eax,ebx
		IP	eax,ebx
		ror	eax,29
		ror	ebx,29
		DES_ENCRYPT          ebx,eax,30,0
		DES_ENCRYPT          eax,ebx,28,0
		DES_ENCRYPT          ebx,eax,26,0
		DES_ENCRYPT          eax,ebx,24,0
		DES_ENCRYPT          ebx,eax,22,0
		DES_ENCRYPT          eax,ebx,20,0
		DES_ENCRYPT          ebx,eax,18,0
		DES_ENCRYPT          eax,ebx,16,0
		DES_ENCRYPT          ebx,eax,14,0
		DES_ENCRYPT          eax,ebx,12,0
		DES_ENCRYPT          ebx,eax,10,0
		DES_ENCRYPT          eax,ebx, 8,0
		DES_ENCRYPT          ebx,eax, 6,0
		DES_ENCRYPT          eax,ebx, 4,0
		DES_ENCRYPT          ebx,eax, 2,0
		DES_ENCRYPT          eax,ebx, 0,0
		ror	eax,3
		ror	ebx,3
		FP	eax,ebx
		mov	edi,[esp+2ch]	; ptrOutdata
		mov	[edi],ebx
		mov	[edi+4],eax
		popad
		ret
		
_3des_decrypt	endp

_move		proc	ptrIndata:DWORD, ptrOutdata:DWORD

		pushad
		mov	esi,[esp+28h]	;ptrIndata
		mov	edi,[esp+2ch]	;ptrOutdata
		mov	ecx,DES_NO_ROUNDKEY	
		cld
		rep	movsd
		popad
		ret
		
_move		endp
