PERM_OP		macro	a,b,n,m

		mov	ebp,a
		shr	ebp,n
		xor	ebp,b
		and	ebp,m		; t
		xor	b,ebp
		shl	ebp,n
		xor	a,ebp
		
endm

HPERM_OP	macro	a,n,m

		mov	ebp,a
		shl	ebp,(16-n)
		xor	ebp,a
		and	ebp,m		; t
		xor	a,ebp
		shr	ebp,(16-n)
		xor	a,ebp
		
endm

_shifts		macro	a,b

		mov	esi,eax		; c
		shr	esi,a
		shl	eax,b
		or	eax,esi
		mov	esi,ebx		; d
		shr	esi,a
		shl	ebx,b
		or	ebx,esi
		mov	_c,eax
		mov	_d,ebx	
		
endm

IP		macro	l,r

		PERM_OP r,l,4,0f0f0f0fh
		PERM_OP l,r,16,0000ffffh
		PERM_OP r,l,2,33333333h
		PERM_OP l,r,8,00ff00ffh
		PERM_OP r,l,1,55555555h
		
endm

FP		macro	l,r

		PERM_OP l,r,1,55555555h
		PERM_OP r,l,8,00ff00ffh
		PERM_OP l,r,2,33333333h
		PERM_OP r,l,16,0000ffffh
		PERM_OP l,r,4,0f0f0f0fh
		
endm

.const

DES_NO_ROUNDS	equ	16
DES_NO_ROUNDKEY	equ	(2*DES_NO_ROUNDS)

.data

shifts2		dd	0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0

.data?

des_roundkey	dd	DES_NO_ROUNDKEY		dup(?)
_c		dd	?
_d		dd	?

.code

des_setkey	proc	ptrInkey:DWORD

		pushad
		mov	esi,[esp+28h]	; ptrInkey
		mov	eax,[esi]		; c
		mov	ebx,[esi+4]	; d
		PERM_OP ebx,eax,4,0f0f0f0fh
		HPERM_OP eax,-2,0cccc0000h
		HPERM_OP ebx,-2,0cccc0000h
		PERM_OP ebx,eax,1,55555555h
		PERM_OP eax,ebx,8,00ff00ffh
		PERM_OP ebx,eax,1,55555555h
		mov	ebp,ebx		; d
		mov	edi,ebx
		mov	esi,eax		; c
		and	ebp,000000ffh
		shl	ebp,16
		and	edi,0000ff00h
		and	ebx,00ff0000h
		shr	ebx,16
		and	esi,0f0000000h
		shr	esi,4
		or	ebx,ebp
		or	ebx,edi
		or	ebx,esi		; d
		and	eax,0fffffffh	; c
		mov	_c,eax
		mov	_d,ebx
		xor	ecx,ecx		; i=0
@_r3:
		mov	eax,_c
		mov	ebx,_d
		cmp	[shifts2+ecx*4],0
		jz	@_r1
		_shifts	2,26
		jmp	@_r2
@_r1:
		_shifts	1,27	
@_r2:
		mov	ebp,eax
		and	ebp,3fh
		mov	edi,[des_skb+0*64*4+ebp*4]	; s = edi
		mov	ebp,eax
		mov	esi,ebp
		shr	ebp,6
		and	ebp,3
		shr	esi,7
		and	esi,3ch
		or	ebp,esi
		or	edi,[des_skb+1*64*4+ebp*4]
		mov	ebp,eax
		mov	esi,ebp
		shr	ebp,13
		and	ebp,0fh
		shr	esi,14
		and	esi,30h
		or	ebp,esi
		or	edi,[des_skb+2*64*4+ebp*4]
		mov	ebp,eax
		mov	esi,ebp
		shr	ebp,20
		and	ebp,1
		shr	esi,21
		and	esi,6
		shr	eax,22
		and	eax,38h
		or	ebp,esi
		or	ebp,eax
		or	edi,[des_skb+3*64*4+ebp*4]	; s
		mov	ebp,ebx
		and	ebp,3fh
		mov	esi,[des_skb+4*64*4+ebp*4]
		mov	ebp,ebx
		mov	edx,ebp
		shr	ebp,7
		and	ebp,3
		shr	edx,8
		and	edx,3ch
		or	ebp,edx
		or	esi,[des_skb+5*64*4+ebp*4]
		mov	ebp,ebx
		shr	ebp,15
		and	ebp,3fh
		or	esi,[des_skb+6*64*4+ebp*4]
		mov	ebp,ebx
		mov	edx,ebp
		shr	ebp,21
		and	ebp,0fh
		shr	edx,22
		and	edx,30h
		or	ebp,edx
		or	esi,[des_skb+7*64*4+ebp*4]	; t
		mov	ebp,esi				; t
		mov	edx,edi				; s
		shl	ebp,16
		and	edx,0000ffffh
		or	ebp,edx				; t2
		ror	ebp,30
		mov	[des_roundkey+ecx*8],ebp
		mov	ebp,edi
		mov	edx,esi
		shr	ebp,16
		and	edx,0ffff0000h
		or	ebp,edx
		ror	ebp,26
		mov	[des_roundkey+ecx*8+4],ebp
		inc	ecx
		cmp	ecx,DES_NO_ROUNDS
		jl	@_r3
		popad
		ret
		
des_setkey	endp